﻿Imports System.Management

Module GMOReport
    Sub Main()
        Dim strUser As String = ""
        Dim strPass As String = ""
        Dim objManagementScope As ManagementScope = ConnectManagementScope("WinSvr2012R2", strUser, strPass)
        objManagementScope.Connect()

        Dim strVMName As String = "VM001"

        'Call DefineVM(objManagementScope, strVMName, "D:\Hyper-V\VM01", 2)
        'Call DeleteVM(objManagementScope, strVMName)
        'Call SetMemory(objManagementScope, strVMName, True, 1024, 512, 2048, 5000, 20)
        'Call CreatePrivateSwitch(objManagementScope, "Private Switch", "プライベート専用")
        'Call CreateInternalSwitch(objManagementScope, "win2012", "Internal Switch", "内部専用")
        'Call CreateExternalSwitch(objManagementScope, "External Switch", "外部専用", "Broadcom BCM5709C NetXtreme II")
        'Call SetConnectNetworkAdapter(objManagementScope, strVMName, "Private Switch", "ネットワーク アダプー")
        'Call RemoveNetworkAdapter(objManagementScope, strVMName, "ネットワーク アダプター")
        Call MigratVM(objManagementScope, strVMName, "Dist_WinSvr2012R2", "D:\Hyper-V\VM01")
    End Sub

    Function ConnectManagementScope(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String) As ManagementScope
        Dim objConnectionOptions As New ConnectionOptions()
        objConnectionOptions.Impersonation = ImpersonationLevel.Impersonate 'WMI への接続に使用される偽装レベルを設定
        objConnectionOptions.EnablePrivileges = True 'WNI経由の操作のためにユーザー特権を有効にする
        objConnectionOptions.Username = strAccount
        objConnectionOptions.Password = strPassword
        Dim objManagementScope As New ManagementScope("\\" + strServer + "\root\virtualization\v2", objConnectionOptions)
        objManagementScope.Connect()
        Return (objManagementScope)
    End Function

    Function DefineVM(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strFolderPath As String, intGeneration As Integer) As Boolean
        Dim objVirtualSystemSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualSystemSettingData"), Nothing)
        Dim objVirtualSystemSettingDataInstance As ManagementObject = objVirtualSystemSettingData.CreateInstance
        objVirtualSystemSettingDataInstance("ElementName") = strVMName
        objVirtualSystemSettingDataInstance("ConfigurationDataRoot") = strFolderPath
        objVirtualSystemSettingDataInstance("VirtualSystemSubType") = "Microsoft:Hyper-V:SubType:" & intGeneration
        objVirtualSystemSettingDataInstance("VirtualNumaEnabled") = False
        Dim strSystemsettingData As String = objVirtualSystemSettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("DefineSystem")
            objParams("SystemSettings") = strSystemsettingData
            objParams("ResourceSettings") = Nothing
            objParams("ReferenceConfiguration") = Nothing
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("DefineSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function DeleteVM(ByVal objManagementScope As ManagementScope, ByVal strVMName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("DestroySystem")
            objParams("AffectedSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("DestroySystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetNumaNode(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, blnEnabled As Boolean) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemSettingData")
            objVirtualSystemsettingData = objManagementObject
            objVirtualSystemsettingData("VirtualNumaEnabled") = blnEnabled
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifySystemSettings")
            objParams("SystemSettings") = objVirtualSystemsettingData.GetText(TextFormat.CimDtd20)
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifySystemSettings", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetMemory(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, blnDynamicMemoryEnabled As Boolean, ByVal intVirtualQuantity As Integer, ByVal intReservation As Integer, ByVal intLimitMemory As Integer, ByVal intWeight As Integer, ByVal intTargetMemoryBuffer As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemSettingData WHERE ElementName = '" & strVMName & "'")).Get
            objVirtualSystemSettingData = objManagementObject
        Next

        Dim objMemorySettingData As ManagementBaseObject = Nothing
        For Each objManagementObject As ManagementObject In objVirtualSystemSettingData.GetRelated("Msvm_MemorySettingData")
            objMemorySettingData = objManagementObject
            objMemorySettingData("DynamicMemoryEnabled") = blnDynamicMemoryEnabled
            objMemorySettingData("VirtualQuantity") = intVirtualQuantity
            objMemorySettingData("Reservation") = intReservation
            objMemorySettingData("Limit") = intLimitMemory
            objMemorySettingData("Weight") = intWeight
            objMemorySettingData("TargetMemoryBuffer") = intTargetMemoryBuffer
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyResourceSettings")
            objParams("ResourceSettings") = New String() {objMemorySettingData.GetText(TextFormat.CimDtd20)}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyResourceSettings", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function CreatePrivateSwitch(ByVal objManagementScope As ManagementScope, ByVal strSwitchName As String, strNote As String) As Boolean
        Dim strVirtualEthernetSwitchSettingData As String = ""
        Dim objVirtualEthernetSwitchSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualEthernetSwitchSettingData"), Nothing)
        Dim objVirtualEthernetSwitchSettingDataInstance As ManagementObject = objVirtualEthernetSwitchSettingData.CreateInstance
        objVirtualEthernetSwitchSettingDataInstance("ElementName") = strSwitchName
        objVirtualEthernetSwitchSettingDataInstance("Notes") = New String() {strNote}
        strVirtualEthernetSwitchSettingData = objVirtualEthernetSwitchSettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualEthernetSwitchManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualEthernetSwitchManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualEthernetSwitchManagementService.GetMethodParameters("DefineSystem")
            objParams("SystemSettings") = strVirtualEthernetSwitchSettingData
            objParams("ResourceSettings") = Nothing
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualEthernetSwitchManagementService.InvokeMethod("DefineSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function CreateInternalSwitch(ByVal objManagementScope As ManagementScope, ByVal strServerName As String, ByVal strSwitchName As String, strNote As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strServerName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim strVirtualEthernetSwitchSettingData As String = ""
        Dim objVirtualEthernetSwitchSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualEthernetSwitchSettingData"), Nothing)
        Dim objVirtualEthernetSwitchSettingDataInstance As ManagementObject = objVirtualEthernetSwitchSettingData.CreateInstance
        objVirtualEthernetSwitchSettingDataInstance("ElementName") = strSwitchName
        objVirtualEthernetSwitchSettingDataInstance("Notes") = New String() {strNote}
        strVirtualEthernetSwitchSettingData = objVirtualEthernetSwitchSettingDataInstance.GetText(TextFormat.CimDtd20)

        Dim strEthernetPortAllocationSettingData As String = ""
        Dim objEthernetPortAllocationSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_EthernetPortAllocationSettingData"), Nothing)
        Dim objEthernetPortAllocationSettingDataInstance As ManagementObject = objEthernetPortAllocationSettingData.CreateInstance
        objEthernetPortAllocationSettingDataInstance("ElementName") = strSwitchName
        objEthernetPortAllocationSettingDataInstance("HostResource") = New String() {objComputerSystem.Path.Path}
        strEthernetPortAllocationSettingData = objEthernetPortAllocationSettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualEthernetSwitchManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualEthernetSwitchManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualEthernetSwitchManagementService.GetMethodParameters("DefineSystem")
            objParams("SystemSettings") = strVirtualEthernetSwitchSettingData
            objParams("ResourceSettings") = New String() {strEthernetPortAllocationSettingData}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualEthernetSwitchManagementService.InvokeMethod("DefineSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function CreateExternalSwitch(ByVal objManagementScope As ManagementScope, ByVal strSwitchName As String, strNote As String, strExternalAdapterName As String) As Boolean
        Dim strVirtualEthernetSwitchSettingData As String = ""
        Dim objVirtualEthernetSwitchSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualEthernetSwitchSettingData"), Nothing)
        Dim objVirtualEthernetSwitchSettingDataInstance As ManagementObject = objVirtualEthernetSwitchSettingData.CreateInstance
        objVirtualEthernetSwitchSettingDataInstance("ElementName") = strSwitchName
        objVirtualEthernetSwitchSettingDataInstance("Notes") = New String() {strNote}
        strVirtualEthernetSwitchSettingData = objVirtualEthernetSwitchSettingDataInstance.GetText(TextFormat.CimDtd20)

        Dim objExternalEthernetPort As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ExternalEthernetPort WHERE Name = '" & strExternalAdapterName & "'")).Get
            objExternalEthernetPort = objManagementObject
        Next

        Dim strEthernetPortAllocationSettingData As String = ""
        Dim objEthernetPortAllocationSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_EthernetPortAllocationSettingData"), Nothing)
        Dim objEthernetPortAllocationSettingDataInstance As ManagementObject = objEthernetPortAllocationSettingData.CreateInstance
        objEthernetPortAllocationSettingDataInstance("ElementName") = strSwitchName
        objEthernetPortAllocationSettingDataInstance("HostResource") = New String() {objExternalEthernetPort.Path.Path}
        strEthernetPortAllocationSettingData = objEthernetPortAllocationSettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualEthernetSwitchManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualEthernetSwitchManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualEthernetSwitchManagementService.GetMethodParameters("DefineSystem")
            objParams("SystemSettings") = strVirtualEthernetSwitchSettingData
            objParams("ResourceSettings") = New String() {strEthernetPortAllocationSettingData}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualEthernetSwitchManagementService.InvokeMethod("DefineSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetConnectNetworkAdapter(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strSwitchName As String, strNetworkAdapterName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemSettingData")
            If String.Compare(objManagementObject("ElementName").ToString, strVMName, True) = 0 Then objVirtualSystemsettingData = objManagementObject
        Next

        Dim objResourcePool As ManagementObject = Nothing
        Dim objNetworkAdapter As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceSubType = 'Microsoft:Hyper-V:Synthetic Ethernet Port' AND Primordial = True")).Get
            objResourcePool = objManagementObject
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objNetworkAdapter = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objNetworkAdapter.Scope = objManagementScope
                        objNetworkAdapter.Get()
                        objNetworkAdapter("VirtualSystemIdentifiers") = New String() {String.Format("{{{0}}}", Guid.NewGuid())}
                        objNetworkAdapter("ElementName") = strNetworkAdapterName
                        objNetworkAdapter("StaticMacAddress") = False
                        Exit For
                    End If
                Next
            Next
        Next

        Dim objAddedNetworkAdapter As ManagementObject = Nothing
        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddResourceSettings")
            objParams("AffectedConfiguration") = objVirtualSystemsettingData.Path.Path
            objParams("ResourceSettings") = New String() {objNetworkAdapter.GetText(TextFormat.WmiDtd20)}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddResourceSettings", objParams, Nothing)
            objAddedNetworkAdapter = New ManagementObject(objManagementBaseObject("ResultingResourceSettings")(0).ToString())
        Next

        Dim objVirtualEthernetSwitch As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualEthernetSwitch WHERE ElementName = '" & strSwitchName & "'")).Get
            objVirtualEthernetSwitch = objManagementObject
        Next

        Dim objEthernetConnection As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceSubType = 'Microsoft:Hyper-V:Ethernet Connection' AND Primordial = True")).Get
            objResourcePool = objManagementObject
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objEthernetConnection = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objEthernetConnection.Scope = objManagementScope
                        objEthernetConnection.Get()
                        objEthernetConnection("Parent") = objAddedNetworkAdapter.Path.Path
                        objEthernetConnection("HostResource") = New String() {objVirtualEthernetSwitch.Path.Path}
                        Exit For
                    End If
                Next
            Next
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddResourceSettings")
            objParams("AffectedConfiguration") = objVirtualSystemsettingData.Path.Path
            objParams("ResourceSettings") = New String() {objEthernetConnection.GetText(TextFormat.WmiDtd20)}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddResourceSettings", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function RemoveNetworkAdapter(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, strNetworkAdapterName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemSettingData")
            If String.Compare(objManagementObject("ElementName").ToString, strVMName, True) = 0 Then objVirtualSystemsettingData = objManagementObject
        Next

        Dim objEthernetPortAllocationSettingData As ManagementObject = Nothing
        Dim objNetworkAdapter As ManagementObject = Nothing
        'ネットワークアダプタが複数ある場合一覧から名前の一致するものを選択
        For Each objManagementObject As ManagementObject In objVirtualSystemsettingData.GetRelated("Msvm_SyntheticEthernetPortSettingData")
            If objManagementObject("ElementName") = strNetworkAdapterName Then
                objNetworkAdapter = objManagementObject
                For Each objManagementObject2 As ManagementObject In objVirtualSystemsettingData.GetRelated("Msvm_EthernetPortAllocationSettingData")
                    objEthernetPortAllocationSettingData = objManagementObject2
                    If objNetworkAdapter.Path.Path = objEthernetPortAllocationSettingData("Parent") Then
                        Exit For
                    End If
                Next
            End If
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("RemoveResourceSettings")
            objParams("ResourceSettings") = New String() {objNetworkAdapter.Path.Path}
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("RemoveResourceSettings", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function
    Function MigratVM(ByVal objManagementScope As ManagementScope, strVMName As String, strDestinationHost As String, ByVal strRootPath As String) As Boolean

        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemSettingData")
            If String.Compare(objManagementObject("ElementName").ToString, strVMName, True) = 0 Then
                objVirtualSystemsettingData = objManagementObject
                If Not strRootPath = "" Then
                    objVirtualSystemsettingData("ConfigurationDataRoot") = strRootPath
                    objVirtualSystemsettingData("SnapshotDataRoot") = strRootPath
                    objVirtualSystemsettingData("SwapFileDataRoot") = strRootPath
                End If
            End If
        Next

        Dim objVirtualSystemMigrationSettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualSystemMigrationSettingData"), Nothing)
        Dim objVirtualSystemMigrationSettingDataInstance As ManagementObject = objVirtualSystemMigrationSettingData.CreateInstance
        objVirtualSystemMigrationSettingDataInstance("MigrationType") = 32771 'VirtualSystem:32768  Storage:32769  Staged:32770  VirtualSystemAndStorage:32771
        objVirtualSystemMigrationSettingDataInstance("TransportType") = 5 'TransportType.Tcp
        objVirtualSystemMigrationSettingDataInstance("EnableCompression") = True

        Dim i As Integer = 0
        Dim strStorageAllocationSettingData() As String
        Dim objHardDisk As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objVirtualSystemsettingData.GetRelated("Msvm_StorageAllocationSettingData")
            If objManagementObject("ResourceSubType") = "Microsoft:Hyper-V:Virtual Hard Disk" Then
                objHardDisk = objManagementObject
                If Not strRootPath = "" Then
                    Dim strVhdPath As String = objHardDisk("HostResource")(0)
                    objHardDisk("HostResource") = New String() {strRootPath & "\" & System.IO.Path.GetFileName(strVhdPath)}
                End If
                ReDim Preserve strStorageAllocationSettingData(i)
                strStorageAllocationSettingData(i) = objHardDisk.GetText(TextFormat.CimDtd20)
                i += 1
            End If
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemMigrationService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("MigrateVirtualSystemToHost")
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            objParams("DestinationHost") = strDestinationHost
            objParams("MigrationSettingData") = objVirtualSystemMigrationSettingDataInstance.GetText(TextFormat.CimDtd20)
            objParams("NewSystemSettingData") = objVirtualSystemsettingData.GetText(TextFormat.CimDtd20)
            objParams("NewResourceSettingData") = strStorageAllocationSettingData
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("MigrateVirtualSystemToHost", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function JobComplete(ByVal objManagementBaseObject As ManagementBaseObject, ByVal objManagementScope As ManagementScope) As Boolean
        'JobState New = 2  Starting = 3  Running = 4  Suspended = 5  ShuttingDown = 6  Completed = 7  Terminated = 8  Killed = 9  Exception = 10  Service = 11
        If objManagementBaseObject("ReturnValue") <> 0 Then
            Dim strJobPath As String = objManagementBaseObject("Job")
            Dim objJob As New ManagementObject(objManagementScope, New ManagementPath(strJobPath), Nothing)
            objJob.Get()
            Do While objJob("JobState") = 3 Or objJob("JobState") = 4
                System.Threading.Thread.Sleep(1000)
                objJob.Get()
            Loop
            If objJob("JobState") <> 7 Then
                Console.WriteLine("ErrorCode=" & objJob("ErrorCode") & " JobState=" & objJob("JobState"))
                Return False
            Else
                Return True
            End If
        Else
            Return True
        End If
    End Function
End Module
